;--------------------------------------------------------------------
; Author       : Kevin Dahl                                         :
; Last Revised : June 7, 1986                                       :
;                                                                   :
; FILENAME - V1.ENH                                                 :
;                                                                   :
; BOARDERCOLOR                                                      :
;        Set the color of the boarder screen for text modes only    :
; ENTRY                                                             :
;        [bp+4] = value in the range 0-15.  It is the color for the :
;                 boarder on the screen.                            :
; EXIT                                                              :
;        Nothing is returned                                        :
;--------------------------------------------------------------------
boardercolor  proc      near
              push      bp                       ; save stack
              mov       bp,sp
              mov       ah,0fh                   ; get current video mode
              int       10h                      ; use BIOS services
              cmp       al,4                     ; is it text modes 0-3?
              jb        v1
              cmp       al,7                     ; is it monochrome?
              jne       v2                       ; graphics mode, exit routine
v1:
              mov       bl,[bp+4]                ; move color into bl
              xor       bh,bh                    ; zero bh
              mov       ah,0Bh                   ; set color palette service
              int       10h                      ; use BIOS services
v2:
              mov       sp,bp                    ; restore stack
              pop       bp
              ret       2                        ; remove params from stack
boardercolor  endp
