;--------------------------------------------------------------------
; Author       : Kevin Dahl                                         :
; Last Revised : June 7, 1986                                       :
;                                                                   :
; FILENAME - V12.ENH                                                :
;                                                                   :
; GOTOXYABS                                                         :
;        Position the cursor at the absolute x,y coordinates on the :
;        screen.                                                    :
;                                                                   :
; ENTRY                                                             :
;        [bp+4] = an integer in the range 1 to 25 giving the row    :
;                 coordinate to place the cursor on the screen.     :
;        [bp+6] = an integer in the range 1 to 40 or 1 to 80,       :
;                 depending on the screen width.  This is the       :
;                 absolute column coordinate to place the cursor in :
;                 on the screen.                                    :
;                                                                   :
; EXIT                                                              :
;        The cursor position is modified.                           :
;--------------------------------------------------------------------
gotoxyabs     proc      near
              push      bp                       ; save stack
              mov       bp,sp
              mov       ah,0fh                   ; get current video mode
              int       10h                      ; use BIOS services
              mov       ah,02h                   ; set cursor position function
              mov       dh,[bp+4]                ; new row of cursor
              mov       dl,[bp+6]                ; new column of cursor
              dec       dh                       ; set for absolute row
              dec       dl                       ; set for absolute col
              int       10h                      ; use BIOS services
              mov       sp,bp                    ; restore stack
              pop       bp
              ret       4                        ; remove params from stack
gotoxyabs     endp
