;--------------------------------------------------------------------
; Author       : Kevin Dahl                                         :
; Last Revised : June 7, 1986                                       :
;                                                                   :
; FILENAME - V2.ENH                                                 :
;                                                                   :
; CLRWIN                                                            :
;        This routine clears the current window on the screen that  :
;        is defined by Turbo                                        :
; ENTRY                                                             :
;        None                                                       :
;                                                                   :
; EXIT                                                              :
;        Nothing is returned                                        :
;--------------------------------------------------------------------
clrwin        proc      near
              push      bp                       ; save stack
              mov       bp,sp
              mov       cx,[0004h]               ; col & row of upper left corner
              mov       dx,cs:[016Ah]            ; col & row of lower right corner
              dec       dh                       ; adjust for absolute lower row
              dec       dl                       ; adjust for absolute right col
              mov       ax,0600h                 ; scroll down - clear window
              mov       bh,[0008h]               ; attribute byte for window color
              push      bp                       ; save base pointer
              int       10h                      ; use BIOS scrolling services
              pop       sp                       ; restore stack pointer
              pop       bp
              ret
clrwin        endp
