;--------------------------------------------------------------------
; Author       : Kevin Dahl                                         :
; Last Revised : June 7, 1986                                       :
;                                                                   :
; FILENAME - V22.ENH                                                :
;                                                                   :
; WHEREXABS                                                         :
;        This routine will return the absolute column coordinate    :
;        of the cursor on the active screen.                        :
;                                                                   :
; EXIT                                                              :
;        AX - The absolute column position of the cursor on the     :
;             active display screen.                                :
;--------------------------------------------------------------------
wherexabs     proc      near
              push      bp                       ; save stack
              mov       bp,sp

              mov       ah,0fh                   ; get current video mode
              int       10h                      ; use BIOS services
              mov       ah,3                     ; read cursor information
              int       10h                      ; use BIOS services
              mov       al,dl                    ; col of cursor into al
              xor       ah,ah                    ; zero out ah register
              inc       ax                       ; adjust for user

              mov       sp,bp                    ; restore stack
              pop       bp                       ; restore base pointer
              ret       2                        ; remove parameters and return
wherexabs     endp

